#include <gmp.h>
#include <stdio.h>

#if __GNU_MP_VERSION <= 2
#error "Your GNU MP library is too old. Please upgrade to at least GMP 3.0"
#endif

typedef struct mppfn_field_s
{
  mp_ptr p;
  mp_size_t size_elt;
  mp_size_t size_sqr;
  mp_size_t size_p;
  mp_size_t size_pol;
  mp_size_t lp;
  mp_size_t lt;
  mp_ptr pol;
  mp_ptr (*alloc)(mp_size_t l);
  void   (*free)(mp_ptr r, mp_size_t l);
  struct mpffn_field_tmp_s *tmp;
  struct mpffn_field_impl_s *impl;
  long padding[32];
} mpffn_field;

#include "mpffn_func.h"
