#! /usr/bin/perl -w

package mp822;
use strict;
sub load 
{
  my $curr="";
  my ($func)=@_;
  while(<>)
  {
    chomp;
    /^@([A-Za-z]+): (.*)$/ or next;
    my $field=$1;
    my $line=$2; 
    chomp $line;
    $curr=$line if ($field eq "function");
    while(<>)
    {
      chomp;
      last if(m{^(@|\*/)});
      $line.="\n$_";
    }
    die("conflicting value for $curr/$field")
      if (defined($func->{$curr}->{$field}) && $func->{$curr}->{$field} ne $line);
    $func->{$curr}->{$field}=$line;
    redo if(m{^(@|\*/)});
  }
}

1;
