#include "mpffn.h"
#include "xmpn.h"

/*
@function: mpffn_neg
@section: mpffn/arith
@proto: void mpffn_neg(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
@desc: Set $r$ to $-x$ in \ff.
*/
void mpffn_neg(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
{
  mpffn_pol_neg(r, x, ff->lt, ff);
}
