#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

mp_size_t mpffn_length(mp_srcptr x, const mpffn_field *ff)
{
  mp_size_t i;
  x+=ff->impl->leader;
  for (i=ff->lt;i && xmpn_is_zero(x,ff->lp); i--)
    x-=ff->lp;
  return i;
}

mp_size_t mpffn_pol_length(mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
{
  mp_size_t i;
  x += (lt-1)*ff->lp;
  for (i=lt;i && xmpn_is_zero(x,ff->lp); i--)
    x-=ff->lp;
  return i;
}
