#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

void mpffn_red(mp_ptr r, mp_ptr x, mp_size_t l, const mpffn_field *ff)
{
  long i;
  long leader =ff->impl->leader;
  long polm =ff->impl->l_pol;
  for(x+=leader, i=ff->lt-1; i>1; i--)
  {
    mpffn_pol_mul_ui(r,ff->pol,polm,x[leader],ff);
    x--;
    mpffn_pol_sub(x,x,r,polm,ff);
  }
  mpffn_pol_mul_ui(r,ff->pol,polm,x[leader],ff);
  mpffn_pol_sub(r,x-1,r,polm,ff);
}
