#include "mpffn.h"
#include "mpffn_priv.h"
#include "xmpn.h"

void mpffn_red(mp_ptr r, mp_ptr x, mp_size_t l, const mpffn_field *ff)
{
  long i;
  mp_size_t leader=ff->impl->leader;
  mp_size_t polm=ff->impl->l_pol;

  for(x+=leader, i=ff->lt-1; i>1; i--)
  {
    mpffn_pol_mul_mpn(r,ff->pol,polm,x+leader,ff);
    x-=ff->lp;
    mpffn_pol_sub(x,x,r,polm,ff);
  }
  mpffn_pol_mul_mpn(r,ff->pol,polm,x+leader,ff);
  mpffn_pol_sub(r,x-ff->lp,r,polm,ff);
}
