#if 0
p=49193;
pol=x^5+2*x^3+x^2+3*x+1;
for(k=1,100,print(lift(Mod(k^2+1,p)^-1)))
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

void
mpff_invmod(mpz_t r, mpz_t x, mpff_field ff)
{
  mpffn_invmod(r->_mp_d,x->_mp_d, ff);
  r->_mp_size=ff->size_p;
}

int main(void)
{
  mpff_field ff;
  mpz_t p,pol;
  mpz_t x,z;
  long k;
  mpz_init_set_ui(p,49193);
  mpz_init_set_str(pol,"1 00000000 00000002 00000001 00000003 00000001",16);
  mpff_field_init(ff,p,pol);
  mpz_init_set_ui(x,17);
  mpz_init2(z,2*mp_bits_per_limb);
  for(k=1;k<=100;k++)
  {
    TIME(
    mpz_set_ui(x,k*k+1);
    mpff_invmod(z,x,ff)
    );
    mpz_out_str(stdout,10,z);
    printf("\n");
  }
  display_time(stderr);
  return 0;
}
