#if 0
p=5;
pol=x^5+2*x^3+x^2+3*x+1;
print(truncate(polrecip(pol)+O(x^5)));
pol*=Mod(1,5);
mg=x/polrecip(pol)+O(x^5);
print(lift(truncate(mg)));
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

int main(void)
{
  mpff_field ff;
  mpz_t p,pol;
  mpff_t x,y,z;
  mpz_init_set_ui(p,5);
  mpz_init_set_str(pol,"1 00000000 00000002 00000001 00000003 00000001",16);
  mpff_field_init_unpack(ff,p,pol,32);
  mpff_init(x,ff);
  mpff_init(y,ff);
  mpff_init(z,ff);
  mpffn_pol_recip(x->d,ff->pol,6,ff);
  mpffn_out_str(stdout,10,x->d,ff);
  fprintf(stdout,"\n");
  mpffn_pol_montgomery(y->d,ff->pol,6,ff);
  mpffn_out_str(stdout,10,y->d,ff);
  fprintf(stdout,"\n");
  return 0;
}
