#if 0
p=17;
pol=x^10 + 15*x^8 + 14*x^7 + 8*x^6 + 13*x^5 + 2*x^4 + 11*x^3 + 11*x^2 + 4*x + 2;
px=x^3+2*x+1;
z=1;
{
  for(i=1,20000,
    z=lift((z*px*Mod(1,17))%pol);
  );
  print(20001,":",z);
}
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

int main(void)
{
  long i;
  mpff_field ff;
  mpz_t p,pol;
  mpz_t px,py;
  mpff_t x,y,z;
  mpz_init_set_ui(p,17);
  mpz_init_set_str(pol,"1  0000000  000000f  000000e  0000008  000000d  0000002  000000b  000000b  0000004  0000002",16);
  mpz_init_set_str(px,"1  00000000  00000002  00000001",16);
  mpz_init_set_str(py,"4  00000000  00000003  00000004",16);
  mpff_field_init_unpack(ff,p,pol,28);
  mpff_init(x,ff);
  mpff_init(y,ff);
  mpff_init(z,ff);
  mpff_unpack_z(x,px,32);
  mpff_unpack_z(y,py,32);
  mpff_set_ui(z,1);
  for(i=1;i<=20000;i++)
  {
    TIME(mpff_mul(z,z,x));
  }
  display_time(stderr);
  printf("%ld:",i);
  mpff_out_str(stdout,10,z);
  printf("\n");
  return 0;
}
