#include "mpffn.h"
#include "xmpn.h"

void mpffn_canon_1(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
{
  long i;
  mp_limb_t p=ff->p[0];
  for(i=0; i<ff->lt; i++, x++, r++)
  { 
    if (x[0]>=p)
      r[0] = x[0]-p;
    else 
      r[0] = x[0];
  }
}

void mpffn_canon(mp_ptr r, mp_srcptr x, const mpffn_field *ff)
{
  long i;
  mp_limb_t p=ff->p[0];
  for(i=0; i<ff->lt; i++, x++, r++)
    r[0] = x[0]%p;
}

void mpffn_pol_canon(mp_ptr r, mp_srcptr x, mp_size_t lt, const mpffn_field *ff)
{
  long i;
  mp_limb_t p=ff->p[0];
  for(i=0; i<lt; i++, x++, r++)
    r[0] = x[0]%p;
}
