#if 0
p=5;
pol=x^5+2*x^3+x^2+3*x+1;
px=x^3+2*x+1;
py=4*x^3+3*x+4;
z=1;
{
  for(i=1,2000,
    print(i,":",z);
    z=lift((z+z*px*Mod(1,5))%pol);
  )
}
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

int main(void)
{
  long i;
  mpff_field ff;
  mpz_t p,pol;
  mpz_t px,py;
  mpff_t x,y,z;
  mpz_init_set_ui(p,5);
  mpz_init_set_str(pol,"1 0 2 1 3 1",16);
  mpz_init_set_str(px,     "1 0 2 1",16);
  mpz_init_set_str(py,     "4 0 3 4",16);
  mpff_field_init_unpack(ff,p,pol,4);
  mpff_init_unpack_z(x,ff,px,4);
  mpff_init_unpack_z(y,ff,py,4);
  mpff_init_set_ui(z,ff,1);
  for(i=1;i<=2000;i++)
  {
    printf("%ld:",i);
    mpff_out_str(stdout,10,z);
    printf("\n");
    TIME(
    mpff_mul(y,z,x);
    mpff_add(z,z,y)
    );
  }
  display_time(stderr);
  return 0;
}
