#if 0
p=5;
pol=x^5+2*x^3+x^2+3*x+1;
px=2*x^3+x^2+3*x+1;
py=Mod(Mod(1,5),pol*Mod(1,5));
for(i=1,100,py=px+py^-1;print(lift(lift(py))));
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

int main(void)
{
  mpff_field ff;
  mpz_t p,pol;
  mpz_t px;
  mpff_t x,y;
  long i;
  mpz_init_set_ui(p,5);
  mpz_init_set_str(pol,"1 00000000 00000002 00000001 00000003 00000001",16);
  mpz_init_set_str(px,"00000002 00000001 00000003 00000001",16);
  mpff_field_init_unpack(ff,p,pol,32);
  mpff_init(x,ff);
  mpff_init(y,ff);
  mpff_unpack_z(x,px,32);
  mpff_set_ui(y,1);
  for(i=1;i<=100;i++)
  {
  TIME(
    mpff_inv(y,y);
    mpff_add(y,x,y)
  );
    mpff_out_str(stdout,10,y);
    printf("\n");
  }
  display_time(stderr);
  return 0;
}
