#if 0
p=1009;
pol=x^1009+x+1;
px=x^1003+2*x+1;
z=1;
{
  for(i=1,200,
    z=lift((z*px*Mod(1,p))%pol);
\\    print(i,":",z);
  )
}
print(z);
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"
long delay;
int main(void)
{
  long i;
  mpff_field ff;
  mpz_t p,pol,N;
  mpz_t px,py;
  mpff_t x,y,z;
  mpz_init_set_ui(p,1009);
  mpz_init(pol);
  mpz_init(N);
  mpz_init(px);
  mpz_ui_pow_ui(N,2,32);
  mpz_pow_ui(pol,N,1009);
  mpz_add(pol,pol,N);
  mpz_add_ui(pol,pol,1);
  mpz_pow_ui(px,N,1003);
  mpz_add(px,px,N);
  mpz_add(px,px,N);
  mpz_add_ui(px,px,1);
  mpz_init_set_str(py,"4  00000000  00000003  00000004",16);
  mpff_field_init_unpack(ff,p,pol,32);
  mpff_init(x,ff);
  mpff_init(y,ff);
  mpff_init(z,ff);
  mpff_unpack_z(x,px,32);
  mpff_unpack_z(y,py,32);
  mpff_set_ui(z,1);
  TIME(
  for(i=1;i<=200;i++)
  {
    mpff_mul(z,z,x);
  /*  printf("%ld:",i);*/
  /*  mpff_out_str(stdout,10,z);*/
  /*  printf("\n");*/
  }
  );
  display_time(stderr);
  mpff_out_str(stdout,10,z);
  printf("\n");
  return 0;
}
