#if 0
p=5;
pol=x^5+2*x^3+x^2+3*x+1;
px=x^3+2*x+1;
py=x^4+4*x^2+2;
print(px);
print(py);
print(lift(py*px%(pol*Mod(1,p))));
quit
#endif
#include <stdio.h>
#include "mpff.h"
#include "timing.h"

int main(void)
{
  mpff_field ff;
  mpz_t p,pol;
  mpz_t px,py;
  mpff_t x,y,z;
  mpz_init_set_ui(p,5);
  mpz_init_set_str(pol,"0000000001 0000000000 0000000002 0000000001 0000000003 0000000001",16);
  mpz_init_set_str(px,   "1021",16);
  mpz_init_set_str(py,  "10402",16);
  mpff_field_init_unpack(ff,p,pol,40);
  mpff_init(x,ff);
  mpff_init(y,ff);
  mpff_init(z,ff);
  mpff_unpack_z(x,px,4);
  mpff_unpack_z(y,py,4);
  mpff_mul(z,x,y);
  mpff_out_str(stdout,10,x);
  printf("\n");
  mpff_out_str(stdout,10,y);
  printf("\n");
  mpff_out_str(stdout,10,z);
  printf("\n");
  return 0;
}

